//serial communication
#include    <stdio.h>      // Standard input/output definitions 
#include    <stdlib.h>     // Standard function library
#include    <unistd.h>     // UNIX standard function definitions
#include    <sys/types.h>  //
#include    <sys/stat.h>   //
#include    <fcntl.h>      // File control definitions
#include    <termios.h>    // POSIX terminal control definitions
#include    <errno.h>      // Error number definitions
#include    <string.h>     // String function definitions

#define FALSE -1
#define TRUE 0

#define RECEIV 16

typedef unsigned char byte;

byte bytesToPHP[RECEIV];   // linked with SensorData

// 1 + 1 + 3*2 + 2*4 = 16 bytes
struct SensorData
{   
    byte tag;
    byte length;
    
    short int tempe;
    short int humid;
    short int light;
    
    float dewPoint;
    unsigned long count;
    
}__attribute__((packed));  // minimum data structure alignment

main()
{
    int fd;
    int i = 0;
    int n = 0;
    
    FILE *fp0;

    struct termios opt; 

    fd = open("[color=Red]/dev/usb/tts/0[/color]", O_RDWR | O_NOCTTY); //ɫҵ·TTLλ
    if(fd == -1)
    {
        perror("open serial 0\n");
        exit(0);
    }

    tcgetattr(fd, &opt);      
    cfsetispeed(&opt, B9600);
    cfsetospeed(&opt, B9600);
    
    if(tcsetattr(fd, TCSANOW, &opt) != 0 )
    {     
       perror("tcsetattr error");
       return -1;
    }
    
    opt.c_cflag &= ~CSIZE;  
    opt.c_cflag |= CS8;   
    opt.c_cflag &= ~CSTOPB; 
    opt.c_cflag &= ~PARENB; 
    
    //opt.c_cflag &= ~INPCK;
    opt.c_cflag |= (CLOCAL | CREAD);
    
    opt.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
 
    opt.c_oflag &= ~OPOST;
    opt.c_oflag &= ~(ONLCR | OCRNL);

    opt.c_iflag &= ~(ICRNL | INLCR);
    opt.c_iflag &= ~(IXON | IXOFF | IXANY);
    
    opt.c_cc[VTIME] = 0;
    opt.c_cc[VMIN] = 0;

    tcflush(fd, TCIOFLUSH);
    
    if(tcsetattr(fd, TCSANOW, &opt) != 0)
    {
        perror("serial error");
        return -1;
    }

//----------------Serial configuration finished-------------------------------------
    sleep(2);
    
    struct SensorData *pSD;
    
    pSD = (struct SensorData *)bytesToPHP;

//----------------Main program start------------------------------------------------

    printf("CoSNet Starting...\n");
    
    while(1)
    {
        sleep(60);
        
        while( (n = read(fd, bytesToPHP, RECEIV)) > 0 )
        {
            if(bytesToPHP[0] == 'F'){printf("error reading sensors\n");}
            
            if( (n == 16) && (bytesToPHP[0] == 'S'))
            {
            
                if( ( fp0 = fopen("/opt/tmp/sensordata.txt","wt") ) == NULL ){exit(1);}
                
                fprintf( fp0,"%c\n%d\n%ld\n%d\n%d\n%d\n%f\n",pSD->tag,pSD->length,pSD->count,pSD->tempe,pSD->humid,pSD->light,pSD->dewPoint);
                
                fclose(fp0);
            }
            
            tcflush(fd, TCIFLUSH);
        }
    }
}

